package org.logi.crypto.test;

import org.logi.crypto.hash.*;
import java.io.*;

/**
 * Compute a hash of the data on standard in and
 * write it to standard out. The name of the hash
 * function is taken on the command line, but defaults
 * to SHA1
 * 
 * @author <a href="http://www.logi.org/~logir/">Logi Ragnarsson</a>
 * (<a href="mailto:logir@logi.org">logir@logi.org</a>)
 */
public class hash {

    private hash(){ }
    
    public static void main (String args[]) throws Exception {
        org.logi.crypto.Crypto.initRandom();
        
        String algorithm="SHA1";
        if(args.length>0)
            algorithm=args[0];
        
        HashState state = HashState.create(algorithm);
        byte[] buf = new byte[state.blockSize()];
        
        int n;
        while (0 <= (n=System.in.read(buf)))
            state.update(buf,0,n);
        
        System.out.println(state.calculate());

    }
    
}
